// EditUzelDlg.cpp : implementation file
//

#include "stdafx.h"
#include "NURBS.h"
#include "EditUzelDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEditUzelDlg dialog


CEditUzelDlg::CEditUzelDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEditUzelDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEditUzelDlg)
	m_pocet = 0;
	m_index = 0;
	m_uzel = 0;
	//}}AFX_DATA_INIT
}


void CEditUzelDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEditUzelDlg)
	DDX_Text(pDX, IDC_POCET, m_pocet);
	DDX_Text(pDX, IDC_INDEX, m_index);
	DDX_Text(pDX, IDC_UZEL, m_uzel);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEditUzelDlg, CDialog)
	//{{AFX_MSG_MAP(CEditUzelDlg)
	ON_BN_CLICKED(IDC_NEXT, OnNext)
	ON_BN_CLICKED(IDC_PREV, OnPrev)
	ON_BN_CLICKED(IDC_LAST, OnLast)
	ON_BN_CLICKED(IDC_FIRST, OnFirst)
	ON_LBN_SELCHANGE(IDC_SEZNAM, OnSelchangeSeznam)
	ON_EN_CHANGE(IDC_UZEL, OnChangeUzel)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEditUzelDlg message handlers

BOOL CEditUzelDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	int i;
	char number[10];
	CListBox* box = ((CListBox*) GetDlgItem(IDC_SEZNAM));
	for (i = 0; i < uzly.GetSize(); i++) {
		sprintf(number, "%-10d", uzly.GetAt(i));
		box->AddString(number);
	}
	box->SetCurSel(m_index - 1);
	
	((CEdit*) GetDlgItem(IDC_INDEX))->SetReadOnly(TRUE);
	((CEdit*) GetDlgItem(IDC_POCET))->SetReadOnly(TRUE);
	
	UpdateData(FALSE);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CEditUzelDlg::OnOK() 
{
	int i;
	for (i = 0; i < (uzly.GetSize() - 1); i++)
		if (uzly.GetAt(i) > uzly.GetAt(i + 1)) {
			AfxMessageBox("Uzlov vektor mus bt neklasajc poslupnost relnch sel.");
			GetDlgItem(IDC_UZEL)->SetFocus();
			((CEdit*) GetDlgItem(IDC_UZEL))->SetSel(0, -1);
			return;
		}
	
	CDialog::OnOK();
}

void CEditUzelDlg::OnNext() 
{
	if (m_index != m_pocet) {
		m_index++;
		m_uzel = uzly.GetAt(m_index - 1);
		UpdateData(FALSE);
		((CListBox*) (GetDlgItem(IDC_SEZNAM)))->SetCurSel(m_index - 1);
	}
	((CEdit*) (GetDlgItem(IDC_UZEL)))->SetFocus();
	((CEdit*) (GetDlgItem(IDC_UZEL)))->SetSel(0, -1);
}

void CEditUzelDlg::OnPrev() 
{
	if (m_index != 1) {
		m_index--;
		m_uzel = uzly.GetAt(m_index - 1);
		UpdateData(FALSE);
		((CListBox*) GetDlgItem(IDC_SEZNAM))->SetCurSel(m_index - 1);
	}
	GetDlgItem(IDC_UZEL)->SetFocus();
	((CEdit*) GetDlgItem(IDC_UZEL))->SetSel(0, -1);
}

void CEditUzelDlg::OnFirst() 
{
	m_index = 1;
	m_uzel = uzly.GetAt(m_index - 1);
	UpdateData(FALSE);
	((CListBox*) GetDlgItem(IDC_SEZNAM))->SetCurSel(m_index - 1);
	GetDlgItem(IDC_UZEL)->SetFocus();
	((CEdit*) GetDlgItem(IDC_UZEL))->SetSel(0, -1);	
}

void CEditUzelDlg::OnLast() 
{
	m_index = m_pocet;
	m_uzel = uzly.GetAt(m_index - 1);
	UpdateData(FALSE);
	((CListBox*) GetDlgItem(IDC_SEZNAM))->SetCurSel(m_index - 1);
	GetDlgItem(IDC_UZEL)->SetFocus();
	((CEdit*) GetDlgItem(IDC_UZEL))->SetSel(0, -1);	
	
}

void CEditUzelDlg::OnSelchangeSeznam() 
{
	int pos = ((CListBox*) GetDlgItem(IDC_SEZNAM))->GetCurSel();
	if (pos == LB_ERR) return;
	m_uzel = uzly.GetAt(pos);
	m_index = pos + 1;
	UpdateData(FALSE);
	GetDlgItem(IDC_UZEL)->SetFocus();
	((CEdit*) GetDlgItem(IDC_UZEL))->SetSel(0, -1);	
}

void CEditUzelDlg::OnChangeUzel() 
{
	char number[10];
	CListBox* box = ((CListBox*) GetDlgItem(IDC_SEZNAM));
	
	UpdateData(TRUE);
	uzly.SetAt(m_index - 1, m_uzel);
	
	box->DeleteString(m_index - 1);
	sprintf(number, "%-10d", m_uzel);
	box->InsertString(m_index - 1, number);
}
